//=============================================================================
// AttachInfo.
//=============================================================================
class AttachInfo expands Info;

// Attach data
var	Actor		Other;
var	Actor		Attached;
var	float		AttachFactor;
var	Vector		AttachOffset;
var	bool		bAttachRotation;

// Linked list data
var	AttachInfo	Previous;
var	AttachInfo	Next;
var	AttachInfo	Root;

static function AttachInfo CreateAttachment(Actor NOther, Actor NAttached, optional float NAttachFactor, optional vector NAttachOffset, optional bool bAttachRotation)
{
	local AttachInfo AI;

	if ( NAttachFactor <= 0 )
		NAttachFactor = 1;

	AI = NOther.Spawn(class'AttachInfo');
	AI.Other = NOther;
	AI.Attached = NAttached;
	AI.AttachFactor = NAttachFactor;
	AI.AttachOffset = NAttachOffset;
	AI.Root = AI;
	AI.bAttachRotation = bAttachRotation;

	return AI;
}


static function AttachInfo FindAttachment(Actor Other)
{
	local AttachInfo AI;

	foreach Other.AllActors(class'AttachInfo', AI)
		if ( AI.Other == Other )
			return AI;
}

static function AttachInfo FindAttached(Actor Other)
{
	local AttachInfo AI;

	foreach Other.AllActors(class'AttachInfo', AI)
		if ( AI.Attached == Other )
			return AI;
}

simulated function Destroyed()
{
    Attached.Velocity.Z += FRand() * 100 + 250;
    Attached.SetPhysics(PHYS_Falling);

	if ( Next != None )
		Next.Destroy();
}

simulated function RemoveAttachment(optional bool bNoDestroy)
{
	if ( Previous != None )
		Previous.Next = Next;

	if ( Next != None )
		Next.Previous = Previous;

	Next = None;
	Previous = None;

	if ( !bNoDestroy )
		Destroy();
}

simulated function AttachInfo AddAttachment(Actor NOther, Actor NAttached, optional float NAttachFactor, optional vector NAttachOffset, optional bool AttachRotation)
{
	if ( AttachFactor <= 0 )
		AttachFactor = 1;

	Next = Spawn(class'AttachInfo');
	Next.Other = NOther;
	Next.Attached = NAttached;
	Next.AttachFactor = NAttachFactor;
	Next.AttachOffset = NAttachOffset;
	Next.Root = Root;
	Next.bAttachRotation = AttachRotation;

	return Next;
}

simulated function Tick(float TimeDelta)
{
	if ( Attached == None || Other == None )
	{
		Destroy();

		return;
	}

	// Attached.Velocity = (Other.Velocity + ((Other.Location + AttachOffset) - Attached.Location)) / TimeDelta * AttachFactor;
	// Attached.SetPhysics(PHYS_Projectile);
    Attached.SetLocation(Other.Location + AttachOffset);
	Attached.SetPhysics(PHYS_Falling);

	if ( bAttachRotation )
		Attached.SetRotation(Other.Rotation);
}

defaultproperties
{
     bAlwaysRelevant=True
}
