//=============================================================================
// BlastBurstTrail.
//=============================================================================
class BlastBurstTrail expands Effects;

var()	float				TrailScale;
var()	float				Speed;
var()	float				OffThrowRandom;
var()	float				ZSpeed;
var()	class<BurstTrail>	TrailType;

simulated function Landed(vector Normal)
{
	HitWall(Normal, None);
}

simulated function HitWall(vector Normal, Actor Wall)
{
	Destroy();
}

simulated function PostBeginPlay()
{
	Velocity = VRand() * Speed;
	Velocity.Z += FRand() + 0.2 * ZSpeed;

	SetTimer(0.2, true);

	SetPhysics(PHYS_Falling);
}

simulated event Timer()
{
	local BurstTrail bt;

	bt = Spawn(TrailType, self);
	bt.DrawScale = DrawScale * TrailScale;
	bt.Velocity = VRand() * OffThrowRandom;
}

defaultproperties
{
}
