#exec texture import name=BloomPart0 file=Textures\BloomPart.pcx group=Bloom
#exec texture import name=BloomPart1 file=Textures\BloomPart1.pcx group=Bloom
#exec texture import name=BloomPart2 file=Textures\BloomPart2.pcx group=Bloom
#exec texture import name=BloomPart3 file=Textures\BloomPart3.pcx group=Bloom

class BloomParticle extends Actor;


var AttachInfo MyAttachment;
var float MyBrightness;

simulated function PreBeginPlay()
{
	if ( RemoteRole == ROLE_Authority && Role != ROLE_Authority )
	{
		DrawType = DT_None;
	
		return;
	}
}

simulated function SetupBloom(Actor Other)
{
	if ( DrawType == DT_None )
		return;
		
	if ( MyAttachment != None )
		MyAttachment.Destroy();
		
	MyAttachment = class'AttachInfo'.static.CreateAttachment(Owner, self, 16, Location - Owner.Location);

	DrawScale = DrawScale * (Other.LightBrightness / 128) + MyBrightness * (Other.LightRadius / 100);
	
	switch ( Other.LightBrightness / 127 * 4 )
	{
		case 3:
			Sprite = Texture'GusPackII.Bloom.BloomPart0';
			Texture = Texture'GusPackII.Bloom.BloomPart0';
			break;
			
		case 2:
			Sprite = Texture'GusPackII.Bloom.BloomPart1';
			Texture = Texture'GusPackII.Bloom.BloomPart1';
			break;
			
		case 1:
			Sprite = Texture'GusPackII.Bloom.BloomPart2';
			Texture = Texture'GusPackII.Bloom.BloomPart2';
			break;
			
		default:
			Sprite = Texture'GusPackII.Bloom.BloomPart3';
			Texture = Texture'GusPackII.Bloom.BloomPart3';
			break;
	}
}

defaultproperties
{
     MyBrightness=1.000000
     Physics=PHYS_Projectile
     RemoteRole=ROLE_SimulatedProxy
     Style=STY_Modulated
     DrawScale=0.500000
     AmbientGlow=180
}
