#exec texture import name=BloomRing file=Textures\BloomRing.pcx group=Bloom

class BloomRing extends Actor;


var float BloomRadius, SpawnBrightness;
var config int Divisions;
var AttachInfo MyAttachment;

simulated function SetupBloom()
{
	local float BloomRadius;
	local Rotator rot;
	local BloomParticle mypart;
	local int i, j;
	
	MyAttachment = class'AttachInfo'.static.CreateAttachment(Owner, self, 16);

	if ( RemoteRole == ROLE_Authority && Role != ROLE_Authority )
	{
		DrawType = DT_None;
	
		return;
	}
	
	DrawScale = Owner.LightRadius / 50;
	BloomRadius = Max(BloomRadius * Owner.LightRadius / 255.0, 48);
	
	for ( rot.Pitch = 0; rot.Pitch < 65536; rot.Pitch += 65536 / Divisions )
		for ( rot.Yaw = 0; rot.Yaw < 65536; rot.Yaw += 65536 / Divisions )
		{
			i++;
		
			if ( FastTrace(Location + Vector(rot) * BloomRadius) )
			{
				j++;
			
				mypart = Spawn(class'GusPackII.BloomParticle', self,, Location + Vector(rot) * BloomRadius);
				mypart.MyBrightness *= SpawnBrightness / Divisions * 1.8;
			
				mypart.SetupBloom(Owner);
			}
		}
		
	Log(self@"spawned"@j@"bloom spheres on"@Owner@"on up to"@i@"rotations on a distance of"@BloomRadius@"with a real light radius of"@Owner.LightRadius);
}

defaultproperties
{
     BloomRadius=1024.000000
     Divisions=8
     Physics=PHYS_Projectile
     RemoteRole=ROLE_SimulatedProxy
     Style=STY_Modulated
     Sprite=Texture'GusPackII.Bloom.BloomRing'
     Texture=Texture'GusPackII.Bloom.BloomRing'
     DrawScale=0.500000
     AmbientGlow=180
}
