class Blooms extends Mutator;


var config float BloomSize, BloomBrightness;
var bool bStarted;

simulated function BeginPlay()
{
	local Actor Other;
	
	Super.BeginPlay();
	
	if ( bStarted ) return;
	
	bStarted = true;

	if ( RemoteRole == ROLE_Authority && Role != ROLE_Authority ) return;
	
	foreach AllActors(class'Actor', Other)
		if ( Other.LightBrightness > 0 && Other.LightType != LT_None && Other.LightRadius > 0 )
			DoBloom(Other);
}

simulated function Timer()
{
	local bool b;
	local Actor Other;
	local BloomRing ring;
	
	foreach AllActors(class'Actor', Other)
	{
		b = false;
		
		if ( Other.LightBrightness == 0 || Other.LightType == LT_None || Other.LightRadius == 0 )
			continue;
		
		foreach Other.ChildActors(class'BloomRing', ring)
			b = true;
			
		if ( !b )
			DoBloom(Other);
	}
}

simulated function DoBloom(Actor Other)
{
	local BloomRing ring;

	ring = Spawn(class'BloomRing', Other,, Other.Location);
	
	ring.BloomRadius *= BloomSize;
	ring.SpawnBrightness *= BloomBrightness;
	
	ring.SetupBloom();
}

defaultproperties
{
     BloomSize=1.200000
     BloomBrightness=0.850000
}
