//=============================================================================
// CoopMatch.
//=============================================================================
class CoopMatch expands TeamGamePlus;

simulated function ScoreKill(Pawn Killer, Pawn Other)
{
    if ( ScriptedPawn(Killer) != None && Other.bIsPlayer )
        return;

    if ( ScriptedPawn(Other) != None && Killer.bIsPlayer )
        Super(DeathMatchPlus).ScoreKill(Killer, Other);
        
    else
        Super.ScoreKill(Killer, Other);
}

function byte AssessBotAttitude(Bot aBot, Pawn Other)
{
    if ( (Other.bIsPlayer && (aBot.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team))
        || (Other.IsA('TeamCannon') 
            && (StationaryPawn(Other).SameTeamAs(aBot.PlayerReplicationInfo.Team))) ) 
        return 5;
        
    else if ( ScriptedPawn(Other) != None && ScriptedPawn(Other).AttitudeTo(aBot) == 1 )
        return 1;
    
    else
        return Super.AssessBotAttitude(aBot, Other);
}

function bool SendBotToGoal(Bot aBot)
{
    local Teleporter Dest, T;
    local int i;
    local bool b;
    
    foreach AllActors(class'Teleporter', T)
    {
        for ( i = 0; i < Len(T.URL); i++ )
            if ( mid(T.URL, i, 1) == "#" )
                b = True;
                
        if ( !b )
            continue;
    
        if ( ( Dest == None || VSize(aBot.Location - T.Location) < VSize(Dest.Location - aBot.Location) ) )
            Dest = T;
    }
        
    if ( Dest != None )
        aBot.MoveTarget = aBot.FindPathToward(Dest);
    
    if ( aBot.MoveTarget == None )
    {
        aBot.bStayFreelance = true;
        aBot.Orders = 'FreeLance';
        if ( aBot.bVerbose && Dest != None )
            log(aBot.PlayerReplicationInfo.PlayerName$" freelance because no path to exit "$Dest$" from "$aBot.Location);
            
        return false;
    }
    
    else
    {
        SetAttractionStateFor(aBot);
        return true;
    }
}

defaultproperties
{
     MaxTeams=1
     StartUpMessage="Work with your teammates against the monsters towards the exit."
     bCoopWeaponMode=True
     MapPrefix=""
     BeaconName="CPMT"
     GameName="Campaign Botmatch"
}
