//=============================================================================
// GrabbingSquid.
//=============================================================================
class GrabbingSquid expands Squid;

var(Squid)	float	GrabChance;

state MeleeAttack
{
ReadyToAttack:
	DesiredRotation = Rotator(Location - Target.Location);

	if ( FRand() < GrabChance / 100 && GrabChance > 0 )
		GoToState('Grabbing');

	PlayMeleeAttack();
	Enable('AnimEnd');
}

state Grabbing
{
	function Tick(float TimeDelta)
	{
		if ( Target == None )
			return;

		Target.Velocity *= -1;
	}

	function BeginState()
	{
		SetRotation(Rotator(Location - Target.Location));
		Target.Velocity = vect(0,0,0);
	}

Begin:
	TweenAnim('Grab', 0.25);
	PlayAnim('Grab', 1.2);

	FinishAnim();

Hold:
	PlayAnim('Hold', 1.05);
	FinishAnim();
	if ( Target == None || Target.IsInState('Dying') || !MeleeDamageTarget(FRand() * 8 + 5, vect(0,0,0)) || FRand() < 0.12 )
		GoTo('Release');

	Health += 16;
	GoTo('Hold');

Release:
	TweenAnim('Release', 0.1);
	PlayAnim('Release', 0.8);

	FinishAnim();
	GoToState('');
}

defaultproperties
{
     GrabChance=37.500000
     TimeBetweenAttacks=0.400000
}
