//=============================================================================
// GusLightmapChunk.
//=============================================================================
class GusLightmapChunk expands Actor;

var GusLightmapChunk	Next;
var GusLightmapChunk	NextTrace;
var GusLightmapChunk	Root;
var	vector				MyNormal;
var float				LightIntensity;
var	float				Precision;
var	float				Attenuation;

function SetUp(optional bool bLog)
{
	if ( bLog )
		Log("Got Lightmap Chunk"@self@"of precision"@Precision@"at location"@Location@"with intensity"@LightIntensity@"and normal"@MyNormal);

	LightBrightness *= LightIntensity / 32;
}

function int TraceSize()
{
	local int i;
	local GusLightmapChunk GLC;

	for ( GLC = self; GLC != None; GLC = GLC.Next )
		i++;

	return i;
}

function PreBeginPlay()
{
	if ( Root == None && GusLightmapChunk(Owner) != None )
		Root = GusLightmapChunk(Owner);

	if ( FRand() < 0.5 )
		LightType = LT_None;
}

function GusLightmapChunk Add()
{
	local Vector Result, Norm;

	if ( Trace(Result, Norm, Location + (MyNormal * Precision)) != None )
	{
		if ( !FastTrace(Location + MyNormal * Precision) )
			return None;

		else
		{
			Next = Spawn(class, self, '', Location + (MyNormal * Precision));

			Next.Precision = Precision;
			Next.MyNormal = MyNormal;
			Next.LightIntensity = LightIntensity * Attenuation;
			Next.Attenuation = Attenuation;
			Next.Root = Root;

			Next.SetUp(false);

			return None;
		}
	}

	Next = Spawn(class, self, '', Location + (MyNormal * Precision));

	Next.Precision = Precision;
	Next.MyNormal = MyNormal;
	Next.LightIntensity = LightIntensity * Attenuation;
	Next.Attenuation = Attenuation;
	Next.Root = Root;

	Next.SetUp(false);

	return Next;
}

defaultproperties
{
     bHidden=True
     Style=STY_Translucent
     DrawScale=0.125000
     LightType=LT_Steady
     LightBrightness=6
     LightSaturation=255
     LightRadius=16
}
