//=============================================================================
// MonsterRide.
//=============================================================================
class MonsterRide expands CodeEvent;

struct MonsterType
{
	var()	bool					bWaterMonster;
	var()	class<ScriptedPawn>		MonsterClass;
	var()	int						Number;
	var()	float					Chance;
};

var()	MonsterType	MonsterClasses[32];

function int MonsterArraySize()
{
	local int i;
	local int j;

	for ( i = 0; i < 32; i++ )
		if ( MonsterClasses[i].MonsterClass == None )
			return i;
}

function MonsterType RandomMonsterClass()
{
	return MonsterClasses[Rand(MonsterArraySize())];
}

function bool PercentChance(float Chance)
{
	return FRand() * 100 < Chance && Chance > 0;
}

function BeginPlay()
{
	local	NavigationPoint	np;
	local	MonsterType		mt;
	local	int				i;

	local	Vector			sl;
	local	Vector			sn;

	foreach AllActors(class'NavigationPoint', np)
	{
		mt = RandomMonsterClass();

		if ( PercentChance(mt.Chance) && ( !mt.bWaterMonster || np.Region.Zone.bWaterZone ) )
			for ( i = 0; i < mt.Number; i++ )
			{
				np.Trace(sl, sn, np.Location + VRand() * mt.MonsterClass.default.CollisionRadius * mt.Number);
				np.Spawn(mt.MonsterClass, np, '__monster_ride__', sl, Rotator(-sn));
			}
	}

	Destroy();
}

defaultproperties
{
     MonsterClasses(0)=(MonsterClass=Class'UnrealShare.Brute',Number=2,Chance=15.000000)
     MonsterClasses(1)=(MonsterClass=Class'UnrealI.Behemoth',Number=1,Chance=8.000000)
     MonsterClasses(2)=(MonsterClass=Class'UnrealShare.LesserBrute',Number=3,Chance=18.000000)
     MonsterClasses(3)=(bWaterMonster=True,MonsterClass=Class'UnrealShare.Devilfish',Number=2,Chance=30.000000)
     MonsterClasses(4)=(MonsterClass=Class'UnrealShare.Fly',Number=4,Chance=28.000000)
     MonsterClasses(5)=(MonsterClass=Class'UnrealI.Mercenary',Number=2,Chance=13.400000)
     MonsterClasses(6)=(MonsterClass=Class'UnrealShare.Manta',Number=2,Chance=19.000000)
     MonsterClasses(7)=(MonsterClass=Class'UnrealShare.CaveManta',Number=3,Chance=19.000000)
     MonsterClasses(8)=(MonsterClass=Class'UnrealI.GiantManta',Number=1,Chance=6.000000)
     MonsterClasses(9)=(MonsterClass=Class'UnrealI.Pupae',Number=4,Chance=19.000000)
     MonsterClasses(10)=(MonsterClass=Class'UnrealI.SkaarjInfantry',Number=1,Chance=7.000000)
     MonsterClasses(11)=(MonsterClass=Class'UnrealI.SkaarjSniper',Number=2,Chance=11.000000)
     MonsterClasses(12)=(MonsterClass=Class'UnrealI.IceSkaarj',Number=1,Chance=3.000000)
     MonsterClasses(13)=(MonsterClass=Class'UnrealShare.SkaarjWarrior',Number=1,Chance=9.000000)
     MonsterClasses(14)=(MonsterClass=Class'UnrealI.SkaarjLord',Number=1,Chance=9.625000)
     MonsterClasses(15)=(MonsterClass=Class'UnrealShare.Slith',Number=2,Chance=17.000000)
}
