#exec mesh import mesh=MBeaconProj anivfile=Models\MBeaconProj_a.3d datafile=Models\MBeaconProj_d.3d x=0 y=0 z=0 mlod=1

#exec mesh sequence mesh=MBeaconProj seq=All startframe=0 numframes=30 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Still startframe=0 numframes=1 rate=1
#exec mesh sequence mesh=MBeaconProj seq=Fire startframe=0 numframes=12 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Down startframe=13 numframes=9 rate=18
#exec mesh sequence mesh=MBeaconProj seq=Select startframe=22 numframes=8 rate=18

#exec meshmap new meshmap=MBeaconProj mesh=MBeaconProj
#exec meshmap scale meshmap=MBeaconProj x=0.1 y=0.1 z=0.2

#exec texture import name=JMBeaconProj file=Textures\JMBeaconProj.pcx group=Skins
#exec meshmap settexture meshmap=MBeaconProj num=0 texture=JMBeaconProj

class MushBeaconProj extends Projectile;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	SetPhysics(PHYS_Projectile);
	Velocity = Vector(Rotation) * speed;
}

simulated function Tick(float TimeDelta)
{
    local Rotator r;
    r = Rotation;

	Super.Tick(TimeDelta);

	if ( Role != ROLE_Authority )
		SetRotation(Rotator(Velocity));
        
    r.Roll += TimeDelta * 65536;
    SetRotation(r);
}

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
	if ( Pawn(Other) != None && Pawn(Other).bIsPlayer && MushMatch(Level.Game) != None && Pawn(Other).PlayerReplicationInfo != None && Pawn(Other).PlayerReplicationInfo.Deaths <= 0 && Instigator != Other )
		MushMatch(Level.Game).StrapBeacon(Pawn(Other), Instigator);
}

defaultproperties
{
     speed=1600.000000
     MaxSpeed=1600.000000
     ImpactSound=Sound'Botpack.Pickups.AmmoPick'
     RemoteRole=ROLE_SimulatedProxy
     Mesh=LodMesh'GusPackII.MBeaconProj'
     DrawScale=0.450000
     CollisionRadius=24.000000
     CollisionHeight=40.000000
}
