class MushMatchHUD extends ChallengeHUD;

#exec texture import name=MMHUDMush group=HUD file=Textures\HudMush.pcx
#exec texture import name=MMHUDHuman group=HUD file=Textures\HudHuman.pcx

simulated function string TeamText(PlayerReplicationInfo PRI)
{
	return MushMatchMutator(Level.Game.BaseMutator).TeamText(PRI, PlayerPawn(Owner));
}

simulated function PostRender(Canvas Drawer)
{
	Super.PostRender(Drawer);
	
	Drawer.DrawColor = HUDColor * 0.75;

	if ( PlayerOwner == none || !PlayerOwner.bIsPlayer || PlayerOwner.PlayerReplicationInfo == none ) return;
	
	Drawer.SetPos(Drawer.SizeX * 0.475, 0);
	
	if ( PlayerOwner.PlayerReplicationInfo.Team == 0 )
		Drawer.DrawIcon(Texture'GusPackII.MMHUDHuman', Drawer.SizeX * 0.05 / 128);
		
	else
		Drawer.DrawIcon(Texture'GusPackII.MMHUDMush', Drawer.SizeX * 0.05 / 128);
		
	Drawer.DrawColor = WhiteColor;
}

simulated function bool DrawIdentifyInfo(canvas Canvas)
{
	if ( !TraceIdentify(Canvas))
		return false;

	if( IdentifyTarget.PlayerName != "" )
	{
		Canvas.Font = MyFonts.GetBigFont(Canvas.ClipX);
		DrawTwoColorID(Canvas, IdentifyName, IdentifyTarget.PlayerName, Canvas.ClipY - 256 * Scale);
		DrawTwoColorID(Canvas, "Status", TeamText(IdentifyTarget), Canvas.ClipY - 224 * Scale);
	}
	
	return true;
}

defaultproperties
{
}
