//=============================================================================
// NavigationHelper.
//=============================================================================
class NavigationHelper expands Pawn;

var	NavigationHelper	Next;
var	Actor				This;

simulated function LoadPathToward(Actor Target, optional NavigationHelper Root)
{
	local NavigationHelper NH;

	if ( Root == None )
		Root = self;

	Next = Spawn(class'NavigationHelper');

	Log(self@"spawned"@Next@"to find path towards"@Target);

	if ( FindPathToward(Target) == None )
	{
		This = Target;
		Next.This = This;
	}

	else
		Next.This = FindPathToward(Target);

	Log(Next@"found next:"@Next.This);
	
	if ( Next.This == Target )
	{
		Log(Next@"found path to target!");
	
		return;
	}

	for ( NH = Root; NH != None; NH = NH.Next )
		if ( NH.This != None && NH.This == Next.This && NH != Next )
		{
			Warn("Avoided recursion because of"@NH.This);

			return;
		}

	Log(self@"takes next path:"@Next@"with"@Next.This);
	Next.LoadPathToward(Target, Root);
}

simulated function Actor Helped(optional bool bThis)
{
	local Actor A, B;

	Log(self@"is self-desctructing");

	if ( Next != None )
		B = Next.Helped();

	else
		A = This;

	if ( bThis )
		A = This;

	else
		A = B;

	Destroy();

	Log("Final path component from"@self$":"@A);

	return A;
}

defaultproperties
{
     bCanTeleport=False
     bAlwaysRelevant=True
     bStasis=False
     bDirectional=False
     bIsKillGoal=False
     bMovable=False
     bCollideActors=False
     bCollideWorld=False
     bBlockActors=False
     bBlockPlayers=False
     bProjTarget=False
}
