//=============================================================================
// NewVehiclePawn.
//=============================================================================
class NewVehiclePawn expands Pawn;

var()	int					VehTeam; // Key access per team. Only the Skaarj can get any team's key ^_^
var()	float				SpeedFactor; // Acceleration speed.
var()	float				RespawnTime; // The mush regenerate quicker than that!
var()	float				MaxSpeed; // Max Speed strikes again... on your engine capacity!
var()	float				HitMomentumFactor; // How far do you go when hit by a... car? I don't want to find out, and you?
var()	float				HitDamageFactor; // ScriptLog: 0 bones broken in hit! | Me: WTF?
var()	float				CorpseTime; // ME: Carcass, how long will you take to despawn? | CARCASS: This is a carcass life, you know. Would you want to suddenly die? :P
 										// ME: BUT I WANT TO DRIVE YOU NOW! | Carcass realizes | CARCASS: I'm not a car-cass, you blind idiot!
var()	float				DecelerationFactor; // Car is slowing down with gravity and resistance.
var()	class<AttachInfo>	AttachmentKind; // The type of glue you bought in store. :P
var()	class<Actor>		DeathActor; // Explosions! :>
var()	Vector				DriverOffset; // Location of seat isn't in engine, unless you want to get burnt :P

var		Pawn				User; // Who's driving? Oh, some guy without the driving license-- wait a second! Come back motherf@!$&r!
var		AttachInfo			Attachment; // Glue the user to the seat for safety. In case of crash the user won't get out. In case of the end of travel... whoops!

function bool Drivable(Actor Other)
{
	return
	(
		Pawn(Other) != None
		&&
		(
			TeamGamePlus(Level.Game) == None
			|| VehTeam < 0
			||
			(
				Pawn(Other).PlayerReplicationInfo != None
				&& Pawn(Other).PlayerReplicationInfo.Team == VehTeam
			)
		)
	);
}

function PreBeginPlay()
{
	if ( AttachmentKind == None )
		AttachmentKind = class'AttachInfo'; // You bought no glue? I'll eat you then use MY super glue as glue! :P
}

function DriverLeft(Pawn Other) // Bye car! <3 ;_;
{
	Attachment.Destroy();
}

function Driving(Pawn Other) // Oh yay new car! :D
{
	Attachment = AttachmentKind.static.CreateAttachment(Other, self,, -DriverOffset);
	Attachment.AddAttachment(self, Other,, DriverOffset);
}

function RunOver(Actor Other)
{
	Other.TakeDamage(HitDamageFactor * VSize(Velocity), User, Location, (Other.Location - Location) * HitMomentumFactor, ''); // Ouch! Look where you drive, freak!

	if ( Pawn(Other) != None && Pawn(Other).Health <= 0 )
		Other.KilledBy(User); // *splatters with a second, and this time proposital hit*
}

function Respawned()
{
	bHidden = False;
}

auto state Empty // No one driving since everyone drank too much!
{
	function Bump(Actor Other) // Our team? Here is key! :P
	{
		if ( Drivable(Other) && User == None )
		{
			User = Pawn(Other);
			Driving(User);
			
			GoToState('Driven');
		}
	}
}

state Driven
{
	function Tick(float TimeDelta) // These are no Non-Touching Seats V2000! Or are they..?
	{
		local Vector v2d;

		if ( User == None )
		{
			GoToState('Empty'); // Empty.

			return;
		}

		if ( User.IsInState('Dying') )
		{
			GoToState('Dying'); // You die, I die. I'm Romeo, and you're Juliet... Wait, kiss? Ew!

			return;	
		}

		v2d = User.Velocity * SpeedFactor;
		v2d.Z = 0;

		Velocity = v2d;
		Acceleration = -Velocity * DecelerationFactor;

		if ( VSize(Velocity) > MaxSpeed )
			Velocity *= MaxSpeed / VSize(Velocity);

		if ( User.Velocity.Z > 32 )
		{
			DriverLeft(User); // Where do you think you going? Will you let them destroy your car while you're away?
			User = None;

			GoToState('Empty');
		}

		else
			User.Velocity.Z -= (User.Velocity.Z * TimeDelta) / 3;
			Velocity.Z -= (User.Velocity.Z * TimeDelta) / 3;
	}

	function Bump(Actor Other) // Sorry, did I *smash your body* apart?
	{
		if ( !Drivable(Other) )
		{
			RunOver(Other); // Ouch.
		}
	}

	function BeginState()
	{
		Log(self@"is now being driven by"@User);
	}

	function bool EncroachingOn(Actor Other) // You can't get hit by a car, inside that car, you know.
	{
		return Other == User;
	}
}

state Sleeping
{
Begin:
	Sleep(RespawnTime); // Respawn like a gun! After driven on the road!
	Respawned();
	
	GoToState('Empty');
}

state Dying
{
	function BeginState()
	{
		local Actor A;

		A = Spawn(DeathActor);
		
		if ( ExplosionChain(A) != None )
		{
			ExplosionChain(A).DelayTime = 0;

			A.GoToState('Exploding');
		}
	}

Begin:
	Sleep(CorpseTime); // Unspawn like a carcass! A metal junk disappears with class!
	bHidden = true;
	Attachment.Destroy();

	GoToState('Sleeping');
}

defaultproperties
{
     Physics=PHYS_Falling
}
