//=============================================================================
// OldVolume.
//=============================================================================
class OldVolume expands Mover;

var()	VolumeModifier		Modifiers;
var()	bool				bDevLog;  // DO NOT set to true if casually mapping!!!!!!!
var		VolumeActors		ActorsInside;
var()	float				ModifierClocking;
var		Actor				GotOut;
var()	class<VolumeActors>	ActorListType;

function NotifyVolumeTouch(Actor Other)
{
	local VolumeModifier VM;

	for ( VM = Modifiers; VM != None; VM = VM.Next )
		VM.VolumeTouch(Other, self, ActorsInside);
}

function ActorInVolume(Actor Other)
{
	local VolumeActors AI;

	if ( Other == None )
		return;

	Log("Volume"@self@"is being occupied by"@Other);

	NotifyVolumeTouch(Other);

	if ( bDevLog )
	{
		Log(ActorsInside@Other);
	}

	if ( ActorsInside == None )
	{
		ActorsInside = Spawn(ActorListType, self);
		ActorsInside.ThisActor = Other;
		
		ActorsInside.SetupBeginPlay();

		return;
	}

	for ( AI = ActorsInside; AI != None; AI = AI.Next )
	{
		if ( bDevLog )
			Log(AI@AI.ThisActor@AI.Next);

		if ( AI.Next == None || ( AI.ThisActor != None && AI.ThisActor == Other ) )
			return;
	}

	AI.AddActor(Other);
}

function Touch(Actor Other)
{
	if ( GotOut != None && Other == GotOut )
		return;

	GotOut = None;
	ActorInVolume(Other);
}

function bool EncroachingOn(Actor Other)
{
	local	VolumeModifier	VM;

	if ( Modifiers == None )
		return false;

	for ( VM = Modifiers; VM != None; VM = VM.Next )
	{
		if ( VM.BlockActor(Other) )
		{
			Warn(self@"will have to block"@Other@"because of"@VM$"'s BlockActor("$Other$") returning True");

			return true;
		}

		if ( VM.Next == None )
			return false;
	}

	return false;
}

function UnTouch(Actor Other)
{
	local VolumeModifier VM;
	local VolumeActors AI;

	Log(Other@"unnocupied Volume"@self);

	GotOut = Other;

	if ( Modifiers != None )
		for ( VM = Modifiers; VM != None; VM = VM.Next )
			VM.VolumeUntouch(Other, self, ActorsInside);

	for ( AI = ActorsInside; AI != None; AI = AI.Next )
	{
		if ( AI.ThisActor != None && AI.ThisActor == Other )
		{
			Log("Destroying"@AI@"for containing interrupted contact with Actor:"@Other);

			AI.Remove();
		}

		if ( AI.Next == None )
			return;
	}
}

function Timer()
{
	local VolumeModifier VM;
	local VolumeActors AI;

	for ( AI = ActorsInside; AI != None; AI = AI.Next )
	{
		if ( AI.ThisActor == None || ( Pawn(AI.ThisActor) != None && Pawn(AI.ThisActor).IsInState('Dying') ) )
		{
			if ( AI.ThisActor != None )
				Log("Destroying"@AI@"for containing deceased contact with Actor:"@AI.ThisActor);

			else
				Log("Destroying"@AI@"for containing deceased contact with a NoneType!");


			AI.Remove();
		}

		if ( AI.Next == None )
			break;
	}

	for ( VM = Modifiers; VM != None; VM = VM.Next )
	{
		VM.VolumeClock(ModifierClocking, self, ActorsInside);

		if ( VM.Next == None )
			return;
	}
}

function BeginPlay()
{
	local VolumeModifier VM;

	Log("Occupation detection between"@self@"and other actors:"@bCollideActors);

	for ( VM = Modifiers; VM.Next != None; VM = VM.Next )
		VM.GotVolume(self);

	SetTimer(ModifierClocking, True);
}

defaultproperties
{
     ModifierClocking=0.100000
     ActorListType=Class'GusPackII.VolumeActors'
     MoverEncroachType=ME_IgnoreWhenEncroach
     BrushColor=(R=226,G=238,B=2)
     bColored=True
     bBlockActors=False
     bBlockPlayers=False
}
