#exec mesh import mesh=SporeProj anivfile=Models\SporeProj_a.3d datafile=Models\SporeProj_d.3d x=0 y=0 z=0 mlod=1
#exec mesh scale mesh=SporeProj x=1 y=1 z=1

#exec mesh sequence mesh=SporeProj seq=All startframe=0 numframes=1 rate=1
#exec mesh sequence mesh=SporeProj seq=Still startframe=0 numframes=1 rate=1
#exec mesh sequence mesh=SporeProj seq=Flying startframe=0 numframes=7 rate=6

#exec meshmap new meshmap=SporeProj mesh=SporeProj
#exec meshmap scale meshmap=SporeProj x=0.1 y=0.1 z=0.2

#exec texture import name=JSporeProj file=Textures\JSporeProj.pcx group=Skins
#exec meshmap settexture meshmap=SporeProj num=0 texture=JSporeProj

#exec texture import name=SporeDecal file=Textures\SporeDecal.pcx group=Decals

#exec AUDIO IMPORT FILE="Sounds\mm_infect.wav" NAME="Infected" GROUP="MushMatch"

class SporeProj extends Projectile;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	SetPhysics(PHYS_Projectile);
	Velocity = Vector(Rotation) * speed;
    
    SetRotation(Rotator(Velocity));

	if ( RemoteRole == ROLE_Authority )
		LoopAnim('Flying', 6, 0.1);
}

simulated function Tick(float TimeDelta)
{
    local Rotator r;
    r = Rotation;

	Super.Tick(TimeDelta);

	if ( Role != ROLE_Authority )
		SetRotation(Rotator(Velocity));
        
    r.Roll += TimeDelta * 65536;
    SetRotation(r);
}

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
	local Pawn mushed, p;
	local Weapon w;
	
	Super.ProcessTouch(Other, HitLocation);
	
	if ( Instigator == None )
	{
		Warn("Null instigator found!");
	
		return;
	}
	
	if ( Other == Instigator )
	{
		Destroy();
		
		return;
	}
	
	if ( Pawn(Other) != none && Instigator != none && Pawn(Other).bIsPlayer && Pawn(Other).PlayerReplicationInfo != none && Pawn(Other).PlayerReplicationInfo.Team == 0 && Instigator.PlayerReplicationInfo != None && Instigator.PlayerReplicationInfo.Team == 1 )
	{
		mushed = Pawn(Other);
		
		w = mushed.Weapon;
		
		mushmatch(Level.Game).GiveWeapon(mushed, "GusPackII.Sporifier"); // HA! You are now a mush!
		
		while ( mushed.FindInventoryType(class'GusPackII.MushBeacon') != None )
			mushed.FindInventoryType(class'GusPackII.MushBeacon').Destroy();
		
		while ( mushed.FindInventoryType(class'GusPackII.NotMush') != None )
			mushed.FindInventoryType(class'GusPackII.NotMush').Destroy();
		
		mushed.Weapon = w;
		mushed.PlayerReplicationInfo.Team = 1; // 0 = human, 1 = mush
        
		Instigator.PlayerReplicationInfo.Score += 1;
			
		mushmatch(Level.Game).CheckEnd();
		
		if ( mushed.Enemy == Instigator ) mushed.Enemy = none;
		if ( mushed == Instigator.Enemy ) instigator.Enemy = none;
		
		for ( p = Level.PawnList; p != none; p = p.nextPawn )
			if ( p.bIsPlayer && p != mushed && p.PlayerReplicationInfo != none && p.PlayerReplicationInfo.Deaths <= 0 && p.CanSee(mushed) && mushed.PlayerReplicationInfo.Team == 1  && p.PlayerReplicationInfo.Team == 0 )
				mushmatch(Level.Game).SpotMush(mushed, p);
                
        if ( PlayerPawn(mushed) != None && !MushMatch(Level.Game).bMatchEnd )
            mushed.PlayOwnedSound(sound'GusPackII.MushMatch.Infected');
	}

	Destroy();
}

defaultproperties
{
     speed=1000.000000
     MaxSpeed=1000.000000
     MomentumTransfer=4
     ImpactSound=Sound'Botpack.Pickups.AmmoPick'
     RemoteRole=ROLE_SimulatedProxy
     Mesh=LodMesh'GusPackII.SporeProj'
     CollisionRadius=4.000000
     CollisionHeight=4.000000
}
