class StringList extends Info;


var string MyString;
var StringList NextString;

static function StringList SplitSring(string Other, string Separator, Actor Caller)
{
	local int i, last;
	local StringList s;
	
	if ( Separator == "" )
	{
		for ( i = 0; i < Len(Other); i++ )
			if ( s == None )
			{
				s = Caller.Spawn(class'StringList');
				s.MyString = Mid(Other, i, 1);
			}
			
			else
				s.AppendString(Mid(Other, i, 1));
	}
	
	else
	{
		for ( i = 0; i < Len(Other); i++ )
			if ( Mid(Other, i, Len(Separator)) == Separator )
			{
				i += Len(Separator) - 1;
				last = i;
				
				if ( s == None )
				{
					s = Caller.Spawn(class'StringList');
					s.MyString = Mid(Other, last, i - last);
				}
				
				else
					s.AppendString(Mid(Other, last, i - last));
			}
	}
		
	return s;
}

function string JoinList(optional string Separator)
{
	local String s;
	local StringList l;
	
	for ( l = self; l != None; l = l.NextString )
		if ( l.NextString == None )
			s = s $ l.MyString;
			
		else
			s = s $ Separator $ l.MyString;
			
	return s;
}

function string AppendString(string Other)
{
	local StringList s;
	
	for ( s = self; s != None; s = s.NextString ) continue;
	
	s.NextString = Spawn(class'StringList');
	s.NextString.MyString = Other;
}

function string PopIndex(int Index, out StringList NewFirst, coerce out byte bSuccess)
{
	local StringList s, d;
	local int i;

	if ( Index == 0 )
	{
		NewFirst = NextString;
	
		return MyString;
	}
	
	for ( s = self; s.NextString != None; s = s.NextString )
	{
		if ( i == Index - 1 )
		{
			bSuccess = true;
			
			d = s.NextString;
			s.NextString = d.NextString;
			return d.MyString;
		}
		
		i++;
	}
	
	NewFirst = self;
	return "";
}

function int IndexOf(string Other, optional coerce out byte bSuccess)
{
	local StringList s;
	local int i;

	for ( s = self; s != None; s = s.NextString )
	{
		if ( s.MyString == Other )
		{
			bSuccess = true;
			return i;
		}
		
		i++;
	}
	
	return -1;
}

function string FromIndex(coerce int Index, optional coerce out byte bSuccess)
{
	local StringList s;
	local int i;

	for ( s = self; s != None; s = s.NextString )
	{
		if ( i == Index )
		{
			bSuccess = true;
			return s.MyString;
		}
		
		i++;
	}
	
	return "";
}

defaultproperties
{
}
