class TrailSpawner extends Info;

var(Trail)  Texture         TrailSkin;
var(Trail)  class<Actor>    TrailType;
var(Trail)  float           UnitLength;
var(Trail)  float           Precision;
var(Trail)  float           TrailLength;
var(Trail)  byte	        Thickness;
var         Vector          LastPos;
var         Actor           T;

/*
simulated function Destroyed()
{
    SetTimer(0.0, false);
}
*/

simulated static function TrailSpawner MakeTrail(Actor Other)
{
    return Other.Spawn(class'TrailSpawner', Other);
}

simulated function PreBeginPlay()
{
    if ( Owner == None || Precision == 0 )
        Destroy();
}

simulated function PostBeginPlay()
{
    LastPos = Owner.Location;
    SetTimer(1.0 / Precision, true);
    // Log("Trail interval in seconds:"@1.0 / Precision);
}

simulated function Tick(float TimeDelta)
{
    local Actor A;

    if ( Owner == None )
    {
        foreach AllActors(TrailType, A)
            if ( A.Owner == self )
    
        Destroy();
    }
}

simulated function Timer()
{
    if ( Owner == None )
    {
        Destroy();
        return;
    }

    T = Spawn(TrailType, Owner,, LastPos, Rotator(Owner.Location - LastPos));
    
    if ( T == None )
    {
        Destroy();
        return;
    }
    
    T.Lifespan = TrailLength / UnitLength;
    T.DrawScale = VSize(Owner.Location - LastPos) / UnitLength;
    
    if ( Projectile(T) != None )
        Projectile(T).Speed = 0;
        
    T.SetPhysics(PHYS_None);
    T.Velocity = vect(0,0,0);
    T.Skin = TrailSkin;
	T.Fatness = Thickness;
    T.Texture = TrailSkin;
    T.LightType = LT_None;
    
    // Log("Trail scale for"@Owner@"is"@T.DrawScale@"where distance is"@VSize(Owner.Location - LastPos));
    // Log("Trail lifespan for"@Owner@"is"@T.Lifespan@"where the length in sizes is "@TrailLength/UnitLength$");
    
    LastPos = Owner.Location;
}

defaultproperties
{
     TrailSkin=Texture'Botpack.Ammocount.AmmoCountJunk'
     TrailType=Class'UnrealI.Tracer'
     UnitLength=320.000000
     Precision=6.000000
     TrailLength=100.000000
     Thickness=200
}
