//=============================================================================
// VolumeLadder.
//=============================================================================
class VolumeLadder expands VolumeModifier;

var()	float	LadderSpeedScale;
var		Actor	Ignored;

function VolumeClock(float ClockInterval, OldVolume Touched, VolumeActors Actors)
{
	local VolumeActors	VA;
	local Vector		VDist2D;
	local Vector		MDist2D;

	for ( VA = Actors; VA != None; VA = VA.Next )
		if ( Pawn(VA.ThisActor) != None )
		{
			VDist2D = VA.ThisActor.Velocity;
			VDist2D.Z = 0;

			MDist2D = Vector(Rotation);
			MDist2D.Z = 0;

			VA.ThisActor.Velocity.Z = VSize(VDist2D) * (VDist2D dot MDist2D) * LadderSpeedScale;
			VA.ThisActor.Velocity -= VDist2D;
		}
}

function VolumeTouch(Actor Other, OldVolume Touched, VolumeActors Actors)
{
	if ( Ignored == Other )
		Ignored = None;
}

function VolumeUntouch(Actor Other, OldVolume Touched, VolumeActors Actors)
{
	Ignored = Other;

	Other.SetPhysics(PHYS_Falling);
}

defaultproperties
{
     LadderSpeedScale=0.020000
     bDirectional=True
}
