class OptionalFloat extends Actor; // inspired by Java's Optional<Float>

var bool Full;
var float content;

static function OptionalFloat Empty(Actor caller)
{
    return caller.Spawn(class'OptionalFloat');
}

static function OptionalFloat Of(Actor caller, float other)
{
    local OptionalFloat res;
    
    res = caller.Spawn(class'OptionalFloat');
    res.content = other;
    res.Full = true;
    
    return res;
}

function bool IsEmpty()
{
    return !Full;
}

function float Get()
{
    if ( !Full )
    {
        Warn("Calling Get on an empty OptionalFloat object, returning default ("$class.default.content$")");
        return class.default.content;
    }
        
    return content;
}

defaultproperties
{
    bHidden=True
}